# remirepo/fedora spec file for phan
#
# Copyright (c) 2016-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#

# For compatibility with SCL
%undefine __brp_mangle_shebangs

%global gh_commit    d57698bb8a944e9576711215ee90cd87528c5b7c
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     phan
#global gh_date      20150820
%global gh_project   phan
%global psr0         Phan
%global with_tests   0%{!?_without_tests:1}

Name:           %{gh_project}
Version:        1.1.4
Release:        1%{?gh_date?%{gh_date}git%{gh_short}}%{?dist}
Summary:        A static analyzer for PHP

License:        MIT
URL:            https://github.com/%{gh_owner}/%{gh_project}
Source0:        %{name}-%{version}-%{?gh_short}.tgz
Source1:        makesrc.sh

# Use fedora autoloader
Patch0:         %{name}-autoload.patch

BuildArch:      noarch
%if %{with_tests}
BuildRequires:  php(language) >= 7.0.0
BuildRequires:  php-ast >= 0.1.5
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires:  (php-composer(composer/semver) >= 1.4                  with php-composer(composer/semver) < 2)
BuildRequires:  (php-composer(composer/xdebug-handler) >= 1.3          with php-composer(composer/xdebug-handler) < 2)
BuildRequires:  (php-composer(felixfbecker/advanced-json-rpc) >= 3.0.3 with php-composer(felixfbecker/advanced-json-rpc) <  4)
BuildRequires:  (php-composer(microsoft/tolerant-php-parser) >= 0.0.15 with php-composer(microsoft/tolerant-php-parser) <  1)
BuildRequires:  (php-composer(sabre/event) >= 5.0                      with php-composer(sabre/event) <  6)
BuildRequires:  (php-composer(symfony/console) >= 2.8                  with php-composer(symfony/console) <  5)
# remirepo:13
%else
BuildRequires:  php-composer(composer/semver) < 2
BuildRequires:  php-composer(composer/semver) >= 1.4
BuildRequires:  php-composer(composer/xdebug-handler) < 2
BuildRequires:  php-composer(composer/xdebug-handler) >= 1.3
BuildRequires:  php-composer(felixfbecker/advanced-json-rpc) <  4
BuildRequires:  php-composer(felixfbecker/advanced-json-rpc) >= 3.0.3
BuildRequires:  php-composer(microsoft/tolerant-php-parser) <  1
BuildRequires:  php-composer(microsoft/tolerant-php-parser) >= 0.0.15
BuildRequires:  php-composer(sabre/event) <  6
BuildRequires:  php-composer(sabre/event) >= 5.0
BuildRequires:  php-composer(symfony/console) <  4
%endif
BuildRequires:  php-reflection
BuildRequires:  php-ctype
BuildRequires:  php-dom
BuildRequires:  php-filter
BuildRequires:  php-json
BuildRequires:  php-pcntl
BuildRequires:  php-pcre
BuildRequires:  php-posix
BuildRequires:  php-spl
BuildRequires:  php-sysvmsg
BuildRequires:  php-sysvsem
# For tests, from composer.json "require-dev": {
#        "phpunit/phpunit": "^6.3.0"
BuildRequires:  phpunit6 >= 6.3.0
BuildRequires:  php-date
BuildRequires:  php-intl
BuildRequires:  php-soap
%endif
# For autoloader
BuildRequires:  php-composer(fedora/autoloader)

# From composer.json, "require": {
#        "php": "^7.0.0",
#        "ext-filter": "*",
#        "ext-json": "*",
#        "composer/semver": "^1.4",
#        "composer/xdebug-handler": "^1.3",
#        "felixfbecker/advanced-json-rpc": "^3.0.3",
#        "microsoft/tolerant-php-parser": "0.0.15",
#        "sabre/event": "^5.0",
#        "symfony/console": "^2.3|^3.0|~4.0"
Requires:       php(language) >= 7.0.0
Requires:       php-filter
Requires:       php-json
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
# From composer.json, "suggest": {
#        "ext-ast": "Needed for parsing ASTs (unless --use-fallback-parser is used). php-ast ^0.1.5|^1.0.0 is needed.",
#        "ext-tokenizer": "Needed for non-AST support and file/line-based suppressions."
Recommends:     php-ast >= 0.1.5
Recommends:     php-tokenizer
Requires:       (php-composer(composer/semver) >= 1.4                  with php-composer(composer/semver) < 2)
Requires:       (php-composer(composer/xdebug-handler) >= 1.3          with php-composer(composer/xdebug-handler) < 2)
Requires:       (php-composer(felixfbecker/advanced-json-rpc) >= 3.0.3 with php-composer(felixfbecker/advanced-json-rpc) <  4)
Requires:       (php-composer(nikic/php-parser) >= 3.1.1               with php-composer(nikic/php-parser) <  4)
Requires:       (php-composer(microsoft/tolerant-php-parser) >= 0.0.15 with php-composer(microsoft/tolerant-php-parser) <  1)
Requires:       (php-composer(sabre/event) >= 5.0                      with php-composer(sabre/event) <  6)
Requires:       (php-composer(symfony/console) >= 2.8                  with php-composer(symfony/console) <  5)
# remirepo:14
%else
Requires:       php-ast >= 0.1.5
Requires:       php-composer(composer/semver) < 2
Requires:       php-composer(composer/semver) >= 1.4
Requires:       php-composer(composer/xdebug-handler) < 2
Requires:       php-composer(composer/xdebug-handler) >= 1.3
Requires:       php-composer(felixfbecker/advanced-json-rpc) <  4
Requires:       php-composer(felixfbecker/advanced-json-rpc) >= 3.0.3
Requires:       php-composer(microsoft/tolerant-php-parser) <  1
Requires:       php-composer(microsoft/tolerant-php-parser) >= 0.0.15
Requires:       php-composer(sabre/event) <  6
Requires:       php-composer(sabre/event) >= 5.0
Requires:       php-composer(symfony/console) <  4
%endif
# From phpcompatinfo report for 1.1.1
Requires:       php-cli
Requires:       php-ctype
Requires:       php-dom
Requires:       php-reflection
Requires:       php-pcntl
Requires:       php-pcre
Requires:       php-posix
Requires:       php-readline
Requires:       php-spl
Requires:       php-sysvmsg
Requires:       php-sysvsem
# For autoloader
Requires:       php-composer(fedora/autoloader)

# Composer
Provides:       php-composer(etsy/%{gh_project}) = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}


%description
Phan is a static analyzer that looks for common issues and will verify type
compatibility on various operations when type information is available or can
be deduced. Phan does not make any serious attempt to understand flow control
and narrow types based on conditionals.


%prep
%setup -q -n %{gh_project}-%{gh_commit}

%patch0 -p1 -b .rpm

cat << 'EOF' | tee src/autoload.php
<?php
/* Autoloader for etsy/phan and its dependencies */

require_once '%{_datadir}/php/Fedora/Autoloader/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('Phan\\', __DIR__ . '/Phan');
\Fedora\Autoloader\Dependencies::required([
    '%{_datadir}/php/Composer/Semver/autoload.php',
    '%{_datadir}/php/Composer/XdebugHandler/autoload.php',
    '%{_datadir}/php/AdvancedJsonRpc3/autoload.php',
    '%{_datadir}/php/Microsoft/PhpParser/autoload.php',
    '%{_datadir}/php/Sabre/Event5/autoload.php',
    [
        '%{_datadir}/php/Symfony4/Component/Console/autoload.php',
        '%{_datadir}/php/Symfony3/Component/Console/autoload.php',
        '%{_datadir}/php/Symfony/Component/Console/autoload.php',
    ],
]);
EOF

find . -name \*.rpm -delete
chmod +x src/phan.php


%build
: Nothing to build


%install
: Library
mkdir -p   %{buildroot}%{_datadir}/php/
cp -pr src %{buildroot}%{_datadir}/php/%{psr0}

: Plugins
cp -pr .phan/plugins %{buildroot}%{_datadir}/php/%{psr0}/plugins

: Commands
mkdir -p %{buildroot}%{_bindir}
ln -s ../share/php/%{psr0}/phan.php %{buildroot}%{_bindir}/phan
install -Dpm 755 phan_client %{buildroot}%{_bindir}/phan-client


%check
%if %{with_tests}
cat << 'EOF' | tee tests/autoload.php
<?php
require '%{buildroot}%{_datadir}/php/%{psr0}/Phan/Bootstrap.php';
\Fedora\Autoloader\Autoload::addPsr4('Phan\\Tests\\', __DIR__ . '/Phan');
EOF

# NOTICE mosquitto, request and grpc must be disabled
%{_bindir}/phpunit6 -d memory_limit=1G --bootstrap tests/autoload.php --verbose


%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc composer.json
%doc *.md
%{_datadir}/php/%{psr0}
%{_bindir}/phan*


%changelog
* Wed Nov 28 2018 Remi Collet <remi@remirepo.net> - 1.1.4-1
- update to 1.1.4

* Wed Nov 21 2018 Remi Collet <remi@remirepo.net> - 1.1.3-1
- update to 1.1.3

* Tue Nov  6 2018 Remi Collet <remi@remirepo.net> - 1.1.2-1
- update to 1.1.2

* Tue Oct 23 2018 Remi Collet <remi@remirepo.net> - 1.1.1-1
- update to 1.1.1

* Tue Oct  9 2018 Remi Collet <remi@remirepo.net> - 1.1.0-1
- update to 1.1.0

* Wed Oct  3 2018 Remi Collet <remi@remirepo.net> - 1.0.7-1
- update to 1.0.7
- raise dependency on microsoft/tolerant-php-parser 0.0.15
- php-ast is optional

* Wed Sep 26 2018 Remi Collet <remi@remirepo.net> - 1.0.6-1
- update to 1.0.6
- sources from git snapshot

* Sat Sep 22 2018 Remi Collet <remi@remirepo.net> - 1.0.5-1
- update to 1.0.5
- open https://github.com/phan/phan/issues/1986 keep the tests
- keep ast mandatory despite it is now optional

* Mon Sep 10 2018 Remi Collet <remi@remirepo.net> - 1.0.4-1
- update to 1.0.4
- add the upstream plugins
- raise dependency on felixfbecker/advanced-json-rpc 3.0.3

* Sat Sep  8 2018 Remi Collet <remi@remirepo.net> - 1.0.3-1
- update to 1.0.3

* Fri Sep  7 2018 Remi Collet <remi@remirepo.net> - 1.0.2-1
- update to 1.0.2
- raise dependency on composer/xdebug-handler 1.3

* Mon Aug 27 2018 Remi Collet <remi@remirepo.net> - 1.0.1-1
- update to 1.0.1
- raise dependency on microsoft/tolerant-php-parser 0.0.13

* Tue Aug 14 2018 Remi Collet <remi@remirepo.net> - 1.0.0-1
- update to 1.0.0

* Mon Jul 23 2018 Remi Collet <remi@remirepo.net> - 0.12.15-1
- update to 0.12.15

* Mon Jul  9 2018 Remi Collet <remi@remirepo.net> - 0.12.14-1
- update to 0.12.14

* Tue Jun 19 2018 Remi Collet <remi@remirepo.net> - 0.12.13-1
- update to 0.12.13
- raise dependency on microsoft/tolerant-php-parser 0.0.11
- raise dependency on composer/xdebug-handler 1.1

* Mon Jun 11 2018 Remi Collet <remi@remirepo.net> - 0.12.12-1
- update to 0.12.12

* Thu May 31 2018 Remi Collet <remi@remirepo.net> - 0.12.11-1
- update to 0.12.11

* Mon May 28 2018 Remi Collet <remi@remirepo.net> - 0.12.10-1
- update to 0.12.10

* Wed May 23 2018 Remi Collet <remi@remirepo.net> - 0.12.9-1
- update to 0.12.9
- raise dependency on microsoft/tolerant-php-parser 0.0.11

* Sun May 13 2018 Remi Collet <remi@remirepo.net> - 0.12.8-1
- update to 0.12.8

* Tue Apr  3 2018 Remi Collet <remi@remirepo.net> - 0.12.5-1
- update to 0.12.5

* Mon Apr  2 2018 Remi Collet <remi@remirepo.net> - 0.12.4-1
- update to 0.12.4

* Mon Mar 26 2018 Remi Collet <remi@remirepo.net> - 0.12.3-1
- update to 0.12.3
- add dependency on composer/xdebug-handler
- raise dependency on microsoft/tolerant-php-parser 0.0.10

* Sat Mar  3 2018 Remi Collet <remi@remirepo.net> - 0.12.2-1
- Update to 0.12.2

* Thu Mar  1 2018 Remi Collet <remi@remirepo.net> - 0.12.1-1
- Update to 0.12.1

* Mon Feb 26 2018 Remi Collet <remi@remirepo.net> - 0.12.0-1
- Update to 0.12.0
- drop dependency on nikic/PHP-Parser
- add dependency on composer/semver
- same version for PHP 7.0, 7.1 and 7.2

* Thu Feb 15 2018 Remi Collet <remi@remirepo.net> - 0.11.3-1
- Update to 0.11.3
- raise dependency on microsoft/tolerant-php-parser 0.0.9

* Mon Feb 12 2018 Remi Collet <remi@remirepo.net> - 0.11.2-1
- Update to 0.11.2

* Mon Jan 22 2018 Remi Collet <remi@remirepo.net> - 0.11.1-1
- Update to 0.11.1
- raise dependency on felixfbecker/advanced-json-rpc 3.0
- add dependency on microsoft/tolerant-php-parser
- allow Symfony 4

* Sat Nov 18 2017 Remi Collet <remi@remirepo.net> - 0.11.0-1
- Update to 0.11.0
- raise dependency on PHP 7.2

* Sat Nov 18 2017 Remi Collet <remi@remirepo.net> - 0.10.2-1
- Update to 0.10.2

* Sat Oct 21 2017 Remi Collet <remi@remirepo.net> - 0.10.1-1
- Update to 0.10.1
- add dependency on felixfbecker/advanced-json-rpc 2.0
- add dependency on sabre/event 5.0

* Mon Sep 25 2017 Remi Collet <remi@remirepo.net> - 0.10.0-1
- Update to 0.10.0
- raise dependency on ast 0.1.5
- add dependency on nikic/php-parser 3.1.1
- move from etsy/phan to phan/phan

* Wed Aug 16 2017 Remi Collet <remi@remirepo.net> - 0.9.4-1
- Update to 0.9.4

* Wed Jul 12 2017 Remi Collet <remi@remirepo.net> - 0.9.3-1
- Update to 0.9.3
- installation layout match upstream tree
- remove phan-prep command (only an example)
- add phan-client command

* Wed Jun 14 2017 Remi Collet <remi@remirepo.net> - 0.9.2-1
- Update to 0.9.2
- allow Symfony 3
- use phpunit 6

* Thu Mar 16 2017 Remi Collet <remi@remirepo.net> - 0.9.1-1
- Update to 0.9.1
- raise dependency on PHP 7.1
- raise dependency on ast 0.1.4

* Fri Jan 27 2017 Remi Collet <remi@remirepo.net> - 0.8.3-1
- update to 0.8.3

* Thu Jan 26 2017 Remi Collet <remi@remirepo.net> - 0.8.2-1
- update to 0.8.2

* Wed Jan 25 2017 Remi Collet <remi@fedoraproject.org> - 0.8.0-1
- update to 0.8.0

* Fri Dec  9 2016 Remi Collet <remi@fedoraproject.org> - 0.7-1
- update to 0.7

* Thu Nov 24 2016 Remi Collet <remi@fedoraproject.org> - 0.6-1
- initial package

